DebugLoud

;UseDirectX11
Graphics3D 800,600,32,2




vs=RecallVertexShader("vertex_shader")
ps=RecallPixelShader("pixel_shader")
ps2=RecallPixelShader("pixel_shader2")

AddShaderConstant vs,"worldMatrix",15
AddShaderConstant vs,"viewMatrix",17
AddShaderConstant vs,"projectionMatrix",16
addy=AddShaderConstant(vs,"add_y",1,0,0,True)
ValidateConstants vs

colo=AddShaderConstant(ps,"color",4)
ValidateConstants ps

cam=CreateCamera(cam)
cube=CreateCube()
sph=CreateSphere()
MoveEntity sph,-5,0,5

MoveEntity cube,0,0,5

AmbientLight 127,127,127

EntityColor cube,255,255,255
EntityColor sph,255,0,0

EntityVertexShader cube,vs
EntityPixelShader cube,ps

EntityVertexShader sph,vs
EntityPixelShader sph,ps2

value#=0

Repeat
TurnEntity cube,.004,.01,0
MoveEntity sph,.0001,0,0
value=value+.0001
SetFloatConstant addy,value
SetVector4Constant colo,Rnd(.5)+.5,Rnd(.5)+.5,Rnd(.5)+.5,1

RenderWorld
Text 0,0,"Custom shaders are now working!!!!"
Flip 0
Until KeyDown(1)

End



Script vertex_shader("vs_main",1,0)
/*
Test comment
*/
cbuffer constants
{
	float4x4 worldMatrix;
	float4x4 viewMatrix;
	float4x4 projectionMatrix;
	float4 add_y;
}

struct VS_OUTPUT
{
	float4 position : SV_POSITION;
	float4 position0 : POSITION2;
	float4 Color : COLOR;
	float3 normal : NORMAL;
	float2 tex : TEXCOORD0;
};

struct VS_INPUT
{
	float3 position : POSITION;
	float3 normal : NORMAL;
	float4 color : COLOR0;
	float2 tc : TEXCOORD0;
	float2 tc2 : TEXCOORD1;
	float4 instance_m0 : TEXCOORD2;
	float4 instance_m1 : TEXCOORD3;
	float4 instance_m2 : TEXCOORD4;
	float4 instance_m3 : TEXCOORD5;
	float4 Color2 : COLOR1;
};

//---------------------------------------------------------------------
// Name: vs_main()
// Desc: The vertex shader 
//---------------------------------------------------------------------
VS_OUTPUT vs_main(VS_INPUT input)
{
	VS_OUTPUT output;
	output.position = float4(input.position,1);
	output.normal = input.normal;
	output.position0 = output.position;

	output.Color = input.color;

	// Calculate the position of the vertex against the world, view, and projection matrices.
	output.position = mul(output.position, worldMatrix);
	output.position = mul(output.position, viewMatrix);
	output.position = mul(output.position, projectionMatrix);

	// Set the texture
	output.tex = input.tc;

	output.position.y=output.position.y+add_y;

	return output;
}
End Script

Script pixel_shader("ps_main",2,0)
////////////////////////////////////////////////////////////////////////////////
// Filename: Color.ps
////////////////////////////////////////////////////////////////////////////////

cbuffer constants
{
	float4 color;
}

struct VS_OUTPUT
{
	float4 position : SV_POSITION;
	float4 position0 : POSITION2;
	float4 Color : COLOR;
	float3 normal : NORMAL;
	float2 tex : TEXCOORD0;
};


float4 ps_main(VS_OUTPUT Input) : SV_TARGET
{
	float x2=Input.position.x;
	int x3=x2/4.0f;
	if ((x3*4)!=(int)x2)
	{
		return float4(0.0f,0.0f,0.0f,0.0f);
	}
	return color;
}

End Script

Script pixel_shader2("ps_main",2,0)
////////////////////////////////////////////////////////////////////////////////
// Filename: Color.ps
////////////////////////////////////////////////////////////////////////////////

struct VS_OUTPUT
{
	float4 position : SV_POSITION;
	float4 position0 : POSITION2;
	float4 Color : COLOR;
	float3 normal : NORMAL;
	float2 tex : TEXCOORD0;
};


float4 ps_main(VS_OUTPUT Input) : SV_TARGET
{
	float y2=Input.position.y;
	int y3=y2/8.0f;
	if ((y2-(y3*8))<4)
	{
		return float4(0.0f,0.0f,0.0f,0.0f);
	}
	return float4(0.0f,1.0f,0.0f,1.0f);
}

End Script