INCBIN "../../samples/images/stone3.jpg"


DebugLoud
UseDirectX11
Graphics3D 1280,720,32,2

; GUI to draw fps (simple Text doesn't work ??)
UseWindow FirstWindow()
lbl=CreateLabel ("",10,10,250,20,0)

; shaders init
vs = RecallVertexShader("vertex_shader")
ps = RecallPixelShader("pixel_shader")
AddShaderConstant vs,"worldMatrix",15
AddShaderConstant vs,"viewMatrix",17
AddShaderConstant vs,"projectionMatrix",16
ValidateConstants vs

; create a plane grid
segments# = 64 ;           <<<<---- CHANGE THIS
mesh = CreateMesh()
surf = CreateSurface(mesh)
For z# = 0 To segments - 1
For x# = 0 To segments
v1 = AddVertex(surf,x-segments/2,0,z-segments/2,x/segments,(segments-z)/segments)
v2 = AddVertex(surf,x-segments/2,0,z+1-segments/2,x/segments,(segments-z-1)/segments)
If x > 0
AddTriangle(surf,v2,v1,v1-2)
AddTriangle(surf,v2,v1-2,v2-2)
EndIf
Next
Next
UpdateNormals(mesh)		

; applying shaders to entity
EntityVertexShader mesh,vs
EntityPixelShader mesh,ps

; loading a texture
bnk=RecallFile("../../samples/images/stone3.jpg")


tex=LoadTextureFromBank(bnk,9)

bsz=BankSize(bnk)

EntityTexture mesh,tex

; camera position
camera_speed# = 0.1 ;           <<<<---- CHANGE THIS
camera = CreateCamera()
MoveEntity camera,0,200,-200
TurnEntity camera,45,0,0

; fps init
fps_time = MilliSecs()

; debug for mouse movement before we start
msxspd# = MouseXSpeed()
msyspd# = MouseYSpeed()


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
While Not KeyHit(1)

; fps
If MilliSecs()-fps_time >= 1000
fps = fps_count
fps_count = 0
fps_time = MilliSecs()
SetGadgetText lbl,fps + " fps - " + TrisRendered() + " triangles"
Else
fps_count = fps_count + 1
EndIf

; turning the plane grid mesh in order to keep it updating even if the camera is still
TurnEntity mesh,0,0.001,0

; freelook
msxspd# = MouseXSpeed()
msyspd# = MouseYSpeed()
TurnEntity camera,msyspd/10.0,msxspd/10.0,0
RotateEntity camera,EntityPitch(camera),EntityYaw(camera),0
If KeyDown(200) Then MoveEntity camera,0,0,camera_speed
If KeyDown(208) Then MoveEntity camera,0,0,-camera_speed
If KeyDown(203) Then MoveEntity camera,-camera_speed,0,0
If KeyDown(205) Then MoveEntity camera,camera_speed,0,0
MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

RenderWorld

Flip 0

Wend
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


End

;; Vertex Shader ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Script vertex_shader("vs_main",1,0)
/*
Test comment
*/

cbuffer constants
{
	float4x4 worldMatrix;
	float4x4 viewMatrix;
	float4x4 projectionMatrix;
}

struct VS_OUTPUT
{
	float4 position : SV_POSITION;
	float4 position0 : POSITION2;
	float4 Color : COLOR;
	float3 normal : NORMAL;
	float2 tex : TEXCOORD0;
};

struct VS_INPUT
{
	float3 position : POSITION;
	float3 normal : NORMAL;
	float4 color : COLOR0;
	float2 tc : TEXCOORD0;
	float2 tc2 : TEXCOORD1;
	float4 instance_m0 : TEXCOORD2;
	float4 instance_m1 : TEXCOORD3;
	float4 instance_m2 : TEXCOORD4;
	float4 instance_m3 : TEXCOORD5;
	float4 Color2 : COLOR1;
};

VS_OUTPUT vs_main(VS_INPUT input)
{
	VS_OUTPUT output;
	output.position = float4(input.position,1);
	output.normal = input.normal;
	output.position0 = output.position;

	float rand;
	float pi = 3.1415926;

	// Calculate the position of the vertex against the world, view, and projection matrices.
	output.position = mul(output.position, worldMatrix);
	output.position = mul(output.position, viewMatrix);
	output.position = mul(output.position, projectionMatrix);

	// pseudo random number
	rand = frac(tan(fmod(212121212,1000*(output.position.x+output.position.y)*pi)));

	// update vertex Y
	output.position.y = output.position.y + rand*10;

	// update vertex color
	output.Color = input.color;

	// Set the texture
	output.tex = input.tc;
	return output;
}

End Script

;; Pixel Shader ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Script pixel_shader("ps_main",2,0)

// Simple texturing shader

Texture2D shaderTexture;
SamplerState SampleType;

struct VS_OUTPUT
{
	float4 position : SV_POSITION;
	float4 position0 : POSITION2;
	float4 Color : COLOR;
	float3 normal : NORMAL;
	float2 tex : TEXCOORD0;
};

float4 ps_main(VS_OUTPUT Input) : SV_TARGET
{
	return shaderTexture.Sample(SampleType, Input.tex);
}

End Script