Include "includes\cam_generic.hb"
Include "includes\gfx_generic.hb"

DebugLoudAndHarsh

;UseDirectX11

Graphics3D 800,600,0,2
SetBuffer BackBuffer()

SeedRnd MilliSecs ( )

Global br$ = ( Chr$ ( 13 ) + Chr$ ( 10 ) )

Global deltatime#, oldmillisecs#, thistime#

; ------------------------------------------------------------------
;	Game's frames-per-second setting
; ------------------------------------------------------------------

Global gameFPS = 60

Global winwidth = 800
Global winheight = 600
Global windepth = 0
Global winmode = 2

; flag when the camera has just been moved
Global cameramoved

; flag when the camera has just been turned
Global cameraturned

Global QUIT = 0

Global movespeed# = 1.0
Global turnspeed# = 3.0

Global double_movespeed# = 3.0
Global double_turnspeed# = 5.0

Global oldtime = MilliSecs()
Global nowtime

Global hwnd=api_FindWindow("Blitz Runtime Class", APP_TITLE$)

Global game_timer = CreateTimer(60)

Global AWBLEND = AW_BLEND
Global AWCENTER = AW_CENTER
Global AWHORPOS = AW_HOR_POSITIVE
Global AWHORNEG = AW_HOR_NEGATIVE
Global AWSLIDE = AW_SLIDE
Global AWVERPOS = AW_VER_POSITIVE
Global AWVERNEG = AAW_VER_NEGATIVE

Global max_effects = 6

Const SC_MOVE 							= 	  		  $F010
Const SC_MAXIMIZE 						= 	  		  $F030
Const SC_MINIMIZE 						= 	  		  $F020
Const SC_SIZE 							= 	  		  $F000

; Set Window Long
Const GWL_WNDPROC						= 			  (  -4 )
Const GWL_HINSTANCE						= 			  (  -6 )
Const GWL_HWNDPARENT					= 		  	  (  -8 )
Const GWL_STYLE							= 		 	  ( -16 )
Const GWL_EXSTYLE						= 		  	  ( -20 )
Const GWL_USERDATA						=			  ( -21 )
Const GWL_ID							=             ( -12 )

;Set Window Pos
Const SWP_ASYNCWINDOWPOS 				= 	  		  $4000
Const SWP_DEFERERASE 					= 	  		  $2000
Const SWP_DRAWFRAME 					= 	  		  $0020
Const SWP_FRAMECHANGED 					= 	  		  $0020
Const SWP_HIDEWINDOW 					= 	  		  $0080
Const SWP_NOACTIVATE 					= 	  		  $0010
Const SWP_NOCOPYBITS 					= 	  		  $0100
Const SWP_NOMOVE 						= 	  		  $0002
Const SWP_NOOWNERZORDER 				= 	  		  $0200
Const SWP_NOREDRAW 						= 	  		  $0008
Const SWP_NOREPOSITION 					= 	  		  $0200
Const SWP_NOSENDCHANGING 				= 	  		  $0400
Const SWP_NOSIZE  						= 	  		  $0001
Const SWP_NOZORDER 						= 	  		  $0004
Const SWP_SHOWWINDOW 					=     		  $0040

Const CELL_DISTANCE# = 1
 
Const ENABLE_ROTATION% = 1
Const ENABLE_SCALING% = 1

Const OUT_OF_RANGE = -2147483647

Const FPS = 60

;============================================================================================================== 
; PopUp Menu for B3D by East-Power-Soft 
; 
; Needs windows API user32 functions. DECLS on the bottom. 
;============================================================================================================== 
Const IMAGE_BITMAP    = $0 
Const IMAGE_ICON      = $1 
Const LR_LOADFROMFILE = $10 

Const MF_BITMAP       = $4 
Const MF_STRING       = $0 
Const MF_ENABLED      = $0 
Const MF_GRAYED       = $1 
Const MF_CHECKED      = $8 
Const MF_UNCHECKED    = $0 
Const MF_POPUP        = $10 
Const MF_SEPERATOR    = $800 

Const TPM_RETURNCMD   = $100 

;Activates the window. Do not use this value with Const AW_HIDE.
Const AW_ACTIVATE = $20000

;Uses a fade effect. This flag can be used only if hwnd is a top-level window.
Const AW_BLEND = $80000

;Makes the window appear to collapse inward if Const AW_HIDE is used or expand outward if the Const AW_HIDE is not used. The various direction flags have no effect.
Const AW_CENTER = $0010

;Hides the window. By default, the window is shown.
Const AW_HIDE = $10000

;Animates the window from left to right. This flag can be used with roll or slide animation. It is ignored when used with Const AW_CENTER or Const AW_BLEND.
Const AW_HOR_POSITIVE = $0001

;Animates the window from right to left. This flag can be used with roll or slide animation. It is ignored when used with Const AW_CENTER or Const AW_BLEND.
Const AW_HOR_NEGATIVE = $0002

;Uses slide animation. By default, roll animation is used. This flag is ignored when used with Const AW_CENTER.
Const AW_SLIDE = $40000

;Animates the window from top to bottom. This flag can be used with roll or slide animation. It is ignored when used with Const AW_CENTER or Const AW_BLEND.
Const AW_VER_POSITIVE = $0004

;Animates the window from bottom to top. This flag can be used with roll or slide animation. It is ignored when used with Const AW_CENTER or Const AW_BLEND.
Const AW_VER_NEGATIVE = $0008

Const ERROR_ALREADY_EXISTS=183

Const APP_TITLE$ = "GRAPHICS TEST - DX11"

Const max_khhotkeys = 27
Const max_kdhotkeys = 27

Dim status$(maxstatus)
status$(0) = "FPS: "

Dim MD5_x(0)
Dim Word$(1)
Dim HotKeysHit(max_khhotkeys)
Dim HotKeysDown(max_kdhotkeys)
Dim Window_Effect ( max_effects )
Dim A_temp_int_array ( 0 )

Window_Effect ( 0 )  = AWBLEND
Window_Effect ( 1 )  = AWCENTER
Window_Effect ( 2 )  = AWHORPOSITIVE
Window_Effect ( 3 )  = AWHORNEGATIVE
Window_Effect ( 4 )  = AWSLIDE
Window_Effect ( 5 )  = AWVERPOSITIVE
Window_Effect ( 6 )  = AWVERNEGATIVE

; Common keys:
Const VK_LEFTMOUSE                              = $01   ; Left physical mouse button
Const VK_RIGHTMOUSE                             = $02   ; Right physical mouse button
Const VK_MIDDLEMOUSE                            = $04   ; Middle physical mouse button
Const VK_BACKSPACE                              = $08   ; BACKSPACE key
Const VK_TAB                                    = $09   ; TAB key
Const VK_ENTER                                  = $0D   ; ENTER key (Main keyboard or keypad)
Const VK_SHIFT                                  = $10   ; SHIFT key (Left or right)
Const VK_CONTROL                                = $11   ; CTRL key (Left or right)
Const VK_ALT                                    = $12   ; ALT key (Left or right)
Const VK_PAUSE                                  = $13   ; PAUSE key
Const VK_SCROLL                                 = $14   ; SCROLL LOCK key
Const VK_ESCAPE                                 = $1B   ; ESC key
Const VK_SPACE                                  = $20   ; SPACEBAR
Const VK_PGUP                                   = $21   ; PAGE UP key
Const VK_PGDN                                   = $22   ; PAGE DOWN key
Const VK_END                                    = $23   ; END key
Const VK_HOME                                   = $24   ; HOME key
Const VK_LEFT                                   = $25   ; LEFT ARROW key
Const VK_UP                                     = $26   ; UP ARROW key
Const VK_RIGHT                                  = $27   ; RIGHT ARROW key
Const VK_DOWN                                   = $28   ; DOWN ARROW key
Const VK_PRINTSCRN                              = $2C   ; PRINT SCREEN key
Const VK_INSERT                                 = $2D   ; INSERT key
Const VK_DELETE                                 = $2E   ; DELETE key
Const VK_0                                      = $30
Const VK_1                                      = $31
Const VK_2                                      = $32
Const VK_3                                      = $33
Const VK_4                                      = $34
Const VK_5                                      = $35
Const VK_6                                      = $36
Const VK_7                                      = $37
Const VK_8                                      = $38
Const VK_9                                      = $39
Const VK_A                                      = $41
Const VK_B                                      = $42
Const VK_C                                      = $43
Const VK_D                                      = $44
Const VK_E                                      = $45
Const VK_F                                      = $46
Const VK_G                                      = $47
Const VK_H                                      = $48
Const VK_I                                      = $49
Const VK_J                                      = $4A
Const VK_K                                      = $4B
Const VK_L                                      = $4C
Const VK_M                                      = $4D
Const VK_N                                      = $4E
Const VK_O                                      = $4F
Const VK_P                                      = $50
Const VK_Q                                      = $51
Const VK_R                                      = $52
Const VK_S                                      = $53
Const VK_T                                      = $54
Const VK_U                                      = $55
Const VK_V                                      = $56
Const VK_W                                      = $57
Const VK_X                                      = $58
Const VK_Y                                      = $59
Const VK_Z                                      = $5A
Const VK_LEFTWIN                                = $5B   ; Left Windows key
Const VK_RIGHTWIN                               = $5C   ; Right Windows key
Const VK_NUMPAD0                                = $60
Const VK_NUMPAD1                                = $61
Const VK_NUMPAD2                                = $62
Const VK_NUMPAD3                                = $63
Const VK_NUMPAD4                                = $64
Const VK_NUMPAD5                                = $65
Const VK_NUMPAD6                                = $66
Const VK_NUMPAD7                                = $67
Const VK_NUMPAD8                                = $68
Const VK_NUMPAD9                                = $69
Const VK_MULTIPLY                               = $6A   ; Keypad *
Const VK_ADD                                    = $6B   ; Keypad +
Const VK_SEPERATOR                              = $6C   ; Keypad /
Const VK_SUBTRACT                               = $6D   ; Keypad -
Const VK_DECIMAL                                = $6E   ; Keypad .
Const VK_DIVIDE                                 = $6F   ; Keypad \
Const VK_F1                                     = $70
Const VK_F2                                     = $71
Const VK_F3                                     = $72
Const VK_F4                                     = $73
Const VK_F5                                     = $74
Const VK_F6                                     = $75
Const VK_F7                                     = $76
Const VK_F8                                     = $77
Const VK_F9                                     = $78
Const VK_F10                                    = $79
Const VK_F11                                    = $7A
Const VK_F12                                    = $7B
Const VK_NUMLOCK                                = $90  
Const VK_CAPITAL                                = $91   ; CAPS LOCK key
Const VK_LEFTSHIFT                              = $A0   ; Windows 95 does not support the left and right distinguishing constants.     
Const VK_RIGHTSHIFT                             = $A1  
Const VK_LEFTCTRL                               = $A2  
Const VK_RIGHTCTRL                              = $A3  
Const VK_LEFTALT                                = $A4  
Const VK_RIGHTALT                               = $A5
 
; Less common keys:
; Some of the keys here would seem to be common keys, but the documentation does not say they work in 95/98,
; so I did not include them with the other keys above just to be safe.
Const VK_CANCEL                                 = $03   ; Control-break processing
Const VK_X1MOUSE                                = $05   ; Windows 2000/XP: X1 mouse button
Const VK_X2MOUSE                                = $06   ; Windows 2000/XP: X2 mouse button
Const VK_CLEAR                                  = $0C   ; CLEAR key
Const VK_SELECT                                 = $29   ; SELECT key
Const VK_EXECUTE                                = $2B   ; EXECUTE key
Const VK_PRINT                                  = $2A   ; PRINT key
Const VK_HELP                                   = $2F   ; HELP key
Const VK_KANA                                   = $15   ; Input Method Editor (IME) Kana mode
Const VK_HANGUL                                 = $15   ; IME Hangul mode
Const VK_JUNJA                                  = $17   ; IME Junja mode
Const VK_FINAL                                  = $18   ; IME final mode
Const VK_KANJI                                  = $19   ; IME Hanja/Kanji mode 
Const VK_CONVERT                                = $1C   ; IME convert
Const VK_NONCONVERT                             = $1D   ; IME nonconvert
Const VK_ACCEPT                                 = $1E   ; IME accept
Const CK_MODECHANGE                             = $1F   ; IME mode change request
Const VK_APPS                                   = $5D   ; Applications key
Const VK_SLEEP                                  = $5F   ; Computer Sleep key
Const VK_F13                                    = $7C
Const VK_F14                                    = $7D
Const VK_F15                                    = $7E
Const VK_F16                                    = $7F
Const VK_F17                                    = $80
Const VK_F18                                    = $81
Const VK_F19                                    = $82
Const VK_F20                                    = $83
Const VK_F21                                    = $84
Const VK_F22                                    = $85
Const VK_F23                                    = $86
Const VK_F24                                    = $87
Const VK_BROWSER_BACK                           = $A6   ; Windows 2000/XP: Browser Back key
Const VK_BROWSER_FORWARD                        = $A7   ; Windows 2000/XP: Browser Forward key
Const VK_BROWSER_REFRESH                        = $A8   ; Windows 2000/XP: Browser Refresh key
Const VK_BROWSER_STOP                           = $A9   ; Windows 2000/XP: Browser Stop key
Const VK_BROWSER_SEARCH                         = $AA   ; Windows 2000/XP: Browser Search key
Const VK_BROWSER_FAVORITES                      = $AB   ; Windows 2000/XP: Browser Favorites key
Const VK_BROWSER_HOME                           = $AC   ; Windows 2000/XP: Browser Start And Home key
Const VK_VOLUME_MUTE                            = $AD   ; Windows 2000/XP: Volume Mute key
Const VK_VOLUME_DOWN                            = $AE   ; Windows 2000/XP: Volume Down key
Const VK_VOLUME_UP                              = $AF   ; Windows 2000/XP: Volume Up key
Const VK_MEDIA_NEXT_TRACK                       = $B0   ; Windows 2000/XP: Next Track key
Const VK_MEDIA_PREV_TRACK                       = $B1   ; Windows 2000/XP: Previous Track key
Const VK_MEDIA_STOP                             = $B2   ; Windows 2000/XP: Stop Media key
Const VK_MEDIA_PLAY_PAUSE                       = $B3   ; Windows 2000/XP: Play/Pause Media key
Const VK_LAUNCH_MAIL                            = $B4   ; Windows 2000/XP: Start Mail key
Const VK_LAUNCH_MEDIA_SELECT                    = $B5   ; Windows 2000/XP: Select Media key
Const VK_LAUNCH_APP1                            = $B6   ; Windows 2000/XP: Start Application 1 key
Const VK_LAUNCH_APP2                            = $B7   ; Windows 2000/XP: Start Application 2 key     
Const VK_OEM_1                                  = $BA   ; Windows 2000/XP: For the US standard keyboard, the ';:' key
Const VK_OEM_PLUS                               = $BB   ; Windows 2000/XP: For any country/region, the '+' key
Const VK_OEM_COMMA                              = $BC   ; Windows 2000/XP: For any country/region, the ',' key
Const VK_OEM_MINUS                              = $BD   ; Windows 2000/XP: For any country/region, the '-' key
Const VK_OEM_PERIOD                             = $BE   ; Windows 2000/XP: For any country/region, the '.' key
Const VK_OEM_2                                  = $BF   ; Windows 2000/XP: For the US standard keyboard, the '/?' key
Const VK_OEM_3                                  = $C0   ; Windows 2000/XP: For the US standard keyboard, the '`~' key
Const VK_OEM_4                                  = $DB   ; Windows 2000/XP: For the US standard keyboard, the '[{' key
Const VK_OEM_5                                  = $DC   ; Windows 2000/XP: For the US standard keyboard, the '\|' key
Const VK_OEM_6                                  = $DD   ; Windows 2000/XP: For the US standard keyboard, the ']}' key
Const VK_OEM_7                                  = $DE   ; Windows 2000/XP: For the US standard keyboard, the 'single-quote/double-quote' key
Const VK_OEM_8                                  = $DF   ; Used for miscellaneous characters; it can vary by keyboard.
Const VK_ICO_F17                                = $E0  
Const VK_ICO_F18                                = $E1  
Const VK_OEM102                                 = $E2   ; Windows 2000/XP: Either the angle bracket key or the backslash key on the RT 102-key keyboard
Const VK_ICO_HELP                               = $E3
Const VK_ICO_00                                 = $E4  
Const VK_PROCESSKEY                             = $E5   ; Windows 95/98/Me, Windows NT 4.0, Windows 2000/XP: IME PROCESS key
Const VK_ICO_CLEAR                              = $E6
Const VK_PACKET                                 = $E7   ; Windows 2000/XP: Used to pass Unicode characters as if they were keystrokes.
Const VK_OEM_RESET                              = $E9
Const VK_OEM_JUMP                               = $EA
Const VK_OEM_PA1                                = $EB
Const VK_OEM_PA2                                = $EC
Const VK_OEM_PA3                                = $ED
Const VK_OEM_WSCTRL                             = $EE
Const VK_OEM_CUSEL                              = $EF
Const VK_OEM_ATTN                               = $F0
Const VK_OEM_FINNISH                            = $F1
Const VK_OEM_COPY                               = $F2
Const VK_OEM_AUTO                               = $F3
Const VK_OEM_ENLW                               = $F4
Const VK_OEM_BACKTAB                            = $F5
Const VK_ATTN                                   = $F6   ; Attn key
Const VK_CRSEL                                  = $F7   ; CrSel key
Const VK_EXSEL                                  = $F8   ; ExSel key
Const VK_EREOF                                  = $F9   ; Erase EOF key
Const VK_PLAY                                   = $FA   ; Play key
Const VK_ZOOM                                   = $FB   ; Zoom key
Const VK_NONAME                                 = $FC   ; Reserved
Const VK_PA1                                    = $FD   ; PA1 key
Const VK_OEM_CLEAR                              = $FE   ; Clear key

	WindowEffect ( Window_Effect ( 1 ), Window_Effect ( 0 ), 1000 ) 

api_ShowWindow ( SystemProperty$ ( "apphWnd" ), 1 )

Global cam=CreateCamera(0)
PositionEntity cam,0,1,-10,0
CameraRange cam, 0.1, 10000.0

Global sprite=CreateSprite(0)

	Global tex=CreateTexture ( 128, 128, 4 )

		SetBuffer TextureBuffer ( tex )

			Color 0, 64, 0
			
			Text 0, 0, "HELLO WORLD!", 0, 0

		SetBuffer BackBuffer ( )
	
	EntityTexture sprite,tex, 0, 0

prepare_texture ( tex )

Color 255, 255, 255

Global cube=CreateCube(0)
PositionEntity cube,0,0,2,0
ScaleEntity cube,6,2,1,0

Global cube1 = CreateCube ( 0 )
PositionEntity cube1, 0, 1, 10, 0

	While Not KH_ESCAPE ( ) Or QUIT

		Which_KeyHits ( )

		Which_KeyDowns ( )

		If KH_1 ( ) Then mode1=1-mode1
		If KH_2 ( ) Then mode2=1-mode2
		If KH_3 ( ) Then mode3=1-mode3

		If mode1 Then texture_mask_colour ( tex, 0, 255, 0, 55 ) ; will clear green colours within 55 either way, fading.
		If mode2 Then texture_mask_colour ( tex, 0,   0, 0, 50 ) ; will clear black and values 55 close to it.
		If mode3 Then EntityAlpha sprite,0.5 : Else EntityAlpha sprite, 1.0

		UpdateWorld 0
		RenderWorld 0
	
		Text 0,0," Press 1 to mask green from the texture", 0, 0
		Text 0,10," Press 2 to turn on entityalpha ", 0, 0
		Text 0,20," Press 3 to mask black from the texture", 0, 0
		
		VWait 1
	
		Flip 0
		
		Delay 1
	
	Wend

	WindowEffect ( 0, 0, 1500 ) 

	ClearWorld ( 1, 1, 1 )

End

;--------------------------------------------------------------------
;  This function will clear a texture of all it's alpha information |
;--------------------------------------------------------------------
;parameters  =  texture : the texture you wish to clear alpha information from

Function prepare_texture(texture)

	LockBuffer TextureBuffer(texture)

		For loop=0 To TextureWidth(texture)-1
	
			For loop1=0 To TextureHeight(texture)-1
	
				RGB1=ReadPixelFast(loop,loop1,TextureBuffer(texture))
	
				r=(RGB1 And $FF0000)Shr 16;separate out the red
				g=(RGB1 And $FF00) Shr 8;green
				b=RGB1 And $FF;and blue parts of the color
	
				a=(RGB1 And $FF000000)Shr 24
				
				a=255; remove any alpha information currently in the texture.
	
				newrgb= (a Shl 24) Or (r Shl 16) Or (g Shl 8) Or b; combine the ARGB back into a number
	
				WritePixelFast(loop,loop1,newrgb,TextureBuffer(texture)); write the info back to the texture
	
			Next
	
		Next

	UnlockBuffer TextureBuffer(texture)

End Function

;---------------------------------------------------------------------
;  This function will mask the passed across RGB of the texture also |
;  passed across. Do NOT pass across a value for flag if you only    |
;  want to mask an exact colour.                                     |
;---------------------------------------------------------------------
;parameters = texture   : the texture you wish to clear alpha information from
;           = r1        : the red value to mask
;           = g1        : the green value to mask
;           = b1        : the blue value to mask
;           = tolerance : the tolerance value. If set to 0, then the function will only mask the
;                         EXACT colours passed across. Higher value will mask values close to the colour.

Function texture_mask_colour(texture,r1,g1,b1,tolerance=0)
	
	LockBuffer TextureBuffer(texture)

		For loop=0 To TextureWidth(texture)-1

			For loop1=0 To TextureHeight(texture)-1

				RGB1=ReadPixelFast(loop,loop1,TextureBuffer(texture)) ; read the RGB value from the texture

				r=(RGB1 And $FF0000)Shr 16;separate out the red
				g=(RGB1 And $FF00) Shr 8;green
				b=RGB1 And $FF;and blue parts of the color

				a=(RGB1 And $FF000000)Shr 24 ; extract the alpha
	
				If r>=r1-tolerance And r=<r1+tolerance And g=>g1-tolerance And g=<g1+tolerance And b=>b1-tolerance And b=<b1+tolerance Then; check RGB lies with the tolerance
					;temp=((Abs(r-r1)+Abs(g-g1)+Abs(b-b1))/3.0)*4.0 ; alpha the values based on the tolerance value
					a=0;temp
	
				End If
	
				newrgb= (a Shl 24) Or (r Shl 16) Or (g Shl 8) Or b ; combine the ARGB back into one value
	
				WritePixelFast(loop,loop1,newrgb,TextureBuffer(texture)); write back to the texture

			Next

		Next

	UnlockBuffer TextureBuffer(texture)

End Function

Function Which_KeyHits ( )

	HotKeysHit ( 0 )  = KH_X ( )
	HotKeysHit ( 1 )  = KH_C ( )
	HotKeysHit ( 2 )  = KH_O ( )
	HotKeysHit ( 3 )  = KH_S ( )
	HotKeysHit ( 4 )  = KH_SPACE ( )
	HotKeysHit ( 5 )  = KH_I ( )
	HotKeysHit ( 6 )  = KH_E ( )
	HotKeysHit ( 7 )  = KH_N ( )
	HotKeysHit ( 8 )  = KH_Q ( )
	HotKeysHit ( 9 )  = KH_1 ( )
	HotKeysHit ( 10 )  = KH_2 ( )
	HotKeysHit ( 11 )  = KH_TAB ( )
	HotKeysHit ( 12 )  = KH_R ( )
	HotKeysHit ( 13 )  = KH_Z ( )
	HotKeysHit ( 14 )  = KH_LEFT_RETURN ( )
	HotKeysHit ( 15 )  = KH_RIGHT_RETURN ( )
	HotKeysHit ( 16 )  = KH_UP ( )
	HotKeysHit ( 17 )  = KH_DOWN ( )
	HotKeysHit ( 18 )  = KH_LEFT ( )
	HotKeysHit ( 19 )  = KH_RIGHT ( )
	HotKeysHit ( 20 )  = KH_A ( )
	HotKeysHit ( 21 )  = KH_M ( )
			
		For x = 0 To max_khhotkeys
	
			shortcuthit = HotKeysHit ( x ) 
					
		Next
	
		If Not HotKeysDown ( 0 )  And HotKeysDown ( 2 )  And HotKeysDown ( 3 )  And HotKeysDown ( 4 ) 
	
			If HotKeysDown ( 2 )
	
				;CTRL+Q NO INTERFERENCE! =D
				If HotKeysHit ( 8 ) 
	
					WindowEffect ( 0, 0, 1500 ) 
	
					End
	
				EndIf
						
			EndIf

			Adv_Control_Entity ( cam, 1.0, 3.3, 5.0, 5.3 )

		EndIf

	Return shortcuthit

End Function

Function Which_KeyDowns ( )

	HotKeysDown (  0 )  = CONTROL_SHIFT_SPACE ( )
	HotKeysDown (  1 )  = CONTROL_SHIFT ( )
	HotKeysDown (  2 )  = CONTROL ( )
	HotKeysDown (  3 )  = SHIFT ( )
	HotKeysDown (  4 )  = SPACE ( )
	HotKeysDown (  5 )  = CONTROL_SPACE ( )
	HotKeysDown (  6 )  = KD_RETURN ( )

	HotKeysDown (  7 )  = CONTROL_SHIFT_SPACE_UP ( )
	HotKeysDown (  8 )  = CONTROL_SHIFT_SPACE_DOWN ( )
	HotKeysDown (  9 )  = CONTROL_SHIFT_SPACE_LEFT ( )
	HotKeysDown ( 10 )  = CONTROL_SHIFT_SPACE_RIGHT ( )
	HotKeysDown ( 11 )  = CONTROL_SHIFT_SPACE_RETURN ( )

	HotKeysDown ( 12 )  = CONTROL_SHIFT_UP ( )
	HotKeysDown ( 13 )  = CONTROL_SHIFT_DOWN ( )
	HotKeysDown ( 14 )  = CONTROL_SHIFT_LEFT ( )
	HotKeysDown ( 15 )  = CONTROL_SHIFT_RIGHT ( )
	HotKeysDown ( 16 )  = CONTROL_SHIFT_RETURN ( )

	HotKeysDown ( 17 )  = CONTROL_SPACE_UP ( )
	HotKeysDown ( 18 )  = CONTROL_SPACE_DOWN ( )
	HotKeysDown ( 19 )  = CONTROL_SPACE_LEFT ( )
	HotKeysDown ( 20 )  = CONTROL_SPACE_RIGHT ( )
	HotKeysDown ( 21 )  = CONTROL_SPACE_RETURN ( )

	HotKeysDown ( 22 )  = CONTROL_UP ( )
	HotKeysDown ( 23 )  = CONTROL_DOWN ( )
	HotKeysDown ( 24 )  = CONTROL_LEFT ( )
	HotKeysDown ( 25 )  = CONTROL_RIGHT ( )
	HotKeysDown ( 26 )  = CONTROL_RETURN ( )
	HotKeysDown ( 27 )  = KD_X ( )

		For x = 0 To max_kdhotkeys

			shortcutdown = HotKeysDown ( x ) 

		Next

	Return shortcutdown

End Function

Function Adv_Control_Entity ( ent, movespeed# = 1.3, turnspeed# = 3.3, double_movespeed# = 5.0, double_turnspeed# = 5.3 )

	If Not HotKeysDown ( 0 )  Or HotKeysDown ( 1 )  Or HotKeysDown ( 4 ) 

		If Not HotKeysDown ( 2 )  Or HotKeysDown ( 3 ) 

			If W_UP ( ) Then MoveEntity ent, 0, 0, movespeed# : cameramoved = True
			If S_DOWN ( ) Then MoveEntity ent, 0, 0, -movespeed# : cameramoved = True

			If A_LEFT ( ) Then TurnEntity ent, 0, turnspeed#, 0, 1 : cameraturned = True
			If D_RIGHT ( ) Then TurnEntity ent, 0, -turnspeed#, 0, 1 : cameraturned = True

		Else If HotKeysDown ( 3 )

			If W_UP ( ) Then MoveEntity ent, 0, 0, double_movespeed# : cameramoved = True
			If S_DOWN ( ) Then MoveEntity ent, 0, 0, -double_movespeed# :  cameramoved = True

			If A_LEFT ( ) Then TurnEntity ent, 0, double_turnspeed#, 0, 1 : cameraturned = True
			If D_RIGHT ( ) Then TurnEntity ent, 0, -double_turnspeed#, 0, 1 : cameraturned = True

		EndIf

	EndIf

	Return ent

End Function

Function WindowEffect ( visibility = 0, flags = 0, time = 200 ) 

Local varEffect
Local varVisible
Local windowhwnd =SystemProperty$ ( "AppHWND" ) 

If visibility = Thenen varVisible = AW_HIDE
If visibility = Thenen varVisible = AW_ACTIVATE

For x = 0To max_effects - 1

		varEffect = Window_Effect ( x ) 

api_AnimateWindow ( windowhwnd, time, varVisible Or varEffect ) 

Next

End Function

Function PreCache ( )
	cam =CreateCamera ( )
CameraRange cam, 1, 10000
PositionEntity cam, 0, 5000000, 0, 1
RotateEntity cam, -90, 0, 0, 1
RenderWorld
PositionEntity cam, 0, -5000000, 0, 1
RotateEntity cam, 90, 0, 0, 1
RenderWorld
FreeEntity cam
VWait 1
Flip
Delay 1
UpdateWorld
RenderWorld
End Function

; -------------------------------------------------------------------------------------------------------------------------------------
; This function returns 1 if the specified virtual key is being pressed, and 0 if it is not.
;
; Normally, the function checks to see if your application has focus and ignores any keys being held down if it does not, 
; but if you want it to tell you if a key is pressed regardless of whether your app has focus, you can set IgnoreFocus to True.
; -------------------------------------------------------------------------------------------------------------------------------------
Function GDI_GetAsyncKeyState ( VirtualKey, IgnoreFocus=False ) 

If ( IgnoreFocus =Truee ) And (api_GetActiveWindow ( ) = 0 ) Then Return
Return (api_GetAsyncKeyState% ( VirtualKey ) And %1000000000000000 )  > 0

End Function

Function KH_ESCAPE ( )
Return (KeyHit ( 1 ) )
End Function

Function KH_A ( )
Return (KeyHit ( 30 ) )
End Function

Function KH_B ( )
Return (KeyHit ( 48 )  )
End Function

Function KH_C ( )
Return (KeyHit ( 46 ) )
End Function

Function KH_D ( )
Return (KeyHit ( 32 ) )
End Function

Function KH_E ( )
Return (KeyHit ( 18 ) )
End Function

Function KH_F ( )
Return (KeyHit ( 33 ) )
End Function

Function KH_G ( )
Return (KeyHit ( 34 ) )
End Function

Function KH_H ( )
Return (KeyHit ( 35 ) )
End Function

Function KH_I ( )
Return (KeyHit ( 23 ) )
End Function

Function KH_J ( )
Return (KeyHit ( 36 ) )
End Function

Function KH_K ( )
Return (KeyHit ( 37 ) )
End Function

Function KH_L ( )
Return (KeyHit ( 38 ) )
End Function

Function KH_M ( )
Return (KeyHit ( 50 ) )
End Function

Function KH_N ( )
Return (KeyHit ( 49 ) )
End Function

Function KH_O ( )
Return (KeyHit ( 24 ) )
End Function

Function KH_P ( )
Return (KeyHit ( 26 ) )
End Function

Function KH_Q ( )
Return (KeyHit ( 16 ) )
End Function

Function KH_R ( )
Return (KeyHit ( 19 ) )
End Function

Function KH_S ( )
Return (KeyHit ( 31 ) )
End Function

Function KH_T ( )
Return (KeyHit ( 20 ) )
End Function

Function KH_U ( )
Return (KeyHit ( 22 ) )
End Function

Function KH_V ( )
Return (KeyHit ( 47 ) )
End Function

Function KH_W ( )
Return (KeyHit ( 17 ) )
End Function

Function KH_X ( )
Return (KeyHit ( 45 ) )
End Function

Function KH_Y ( )
Return (KeyHit ( 21 ) )
End Function

Function KH_Z ( )
Return (KeyHit ( 44 ) )
End Function

Function KH_UP ( )
Return (KeyHit ( 200 ) )
End Function

Function KH_DOWN ( )
Return (KeyHit ( 208 ) )
End Function

Function KH_LEFT ( )
Return (KeyHit ( 203 ) )
End Function

Function KH_RIGHT ( )
Return (KeyHit ( 205 ) )
End Function

Function KH_SPACE ( )
Return (KeyHit ( 57 ) )
End Function

Function KH_BACKSPACE ( )
Return (KeyHit ( 14 )  )
End Function

Function KH_1 ( )
Return (KeyHit ( 2 ) )
End Function

Function KH_2 ( )
Return (KeyHit ( 3 ) )
End Function

Function KH_3 ( )
Return (KeyHit ( 4 ) )
End Function

Function KH_4 ( )
Return (KeyHit ( 5 ) )
End Function

Function KH_5 ( )
Return (KeyHit ( 6 ) )
End Function

Function KH_6 ( )
Return (KeyHit ( 7 ) )
End Function

Function KH_7 ( )
Return (KeyHit ( 8 ) )
End Function

Function KH_8 ( )
Return (KeyHit ( 9 ) )
End Function

Function KH_9 ( )
Return (KeyHit ( 10 ) )
End Function

Function KH_0 ( )
Return (KeyHit ( 11 ) )
End Function

Function KH_TAB ( )
Return (KeyHit ( 15 ) )
End Function

Function KH_LEFT_RETURN ( )
Return (KeyHit ( 28 ) )
End Function

Function KH_RIGHT_RETURN ( )
Return (KeyHit ( 156 ) )
End Function

Function KD_ESCAPE ( )
Return ( GDI_GetAsyncKeyState ( VK_ESCAPE, 1 ) )
End Function

Function KD_A ( )
Return ( GDI_GetAsyncKeyState ( VK_A, 1 ) )
End Function

Function KD_B ( )
Return ( GDI_GetAsyncKeyState ( VK_B, 1 ) )
End Function

Function KD_C ( )
Return ( GDI_GetAsyncKeyState ( VK_C, 1 ) )
End Function

Function KD_D ( )
Return ( GDI_GetAsyncKeyState ( VK_D, 1 ) )
End Function

Function KD_E ( )
Return ( GDI_GetAsyncKeyState ( VK_E, 1 ) )
End Function

Function KD_F ( )
Return ( GDI_GetAsyncKeyState ( VK_F, 1 ) )
End Function

Function KD_G ( )
Return ( GDI_GetAsyncKeyState ( VK_G, 1 ) )
End Function

Function KD_H ( )
Return ( GDI_GetAsyncKeyState ( VK_H, 1 ) )
End Function

Function KD_I ( )
Return ( GDI_GetAsyncKeyState ( VK_I, 1 ) )
End Function

Function KD_J ( )
Return ( GDI_GetAsyncKeyState ( VK_J, 1 ) )
End Function

Function KD_K ( )
Return ( GDI_GetAsyncKeyState ( VK_K, 1 ) )
End Function

Function KD_L ( )
Return ( GDI_GetAsyncKeyState ( VK_L, 1 ) )
End Function

Function KD_M ( )
Return ( GDI_GetAsyncKeyState ( VK_M, 1 ) )
End Function

Function KD_N ( )
Return ( GDI_GetAsyncKeyState ( VK_N, 1 ) )
End Function

Function KD_O ( )
Return ( GDI_GetAsyncKeyState ( VK_O, 1 ) )
End Function

Function KD_P ( )
Return ( GDI_GetAsyncKeyState ( VK_P, 1 ) )
End Function

Function KD_Q ( )
Return ( GDI_GetAsyncKeyState ( VK_Q, 1 ) )
End Function

Function KD_R ( )
Return ( GDI_GetAsyncKeyState ( VK_R, 1 ) )
End Function

Function KD_S ( )
Return ( GDI_GetAsyncKeyState ( VK_S, 1 ) )
End Function

Function KD_T ( )
Return ( GDI_GetAsyncKeyState ( VK_T, 1 ) )
End Function

Function KD_U ( )
Return ( GDI_GetAsyncKeyState ( VK_U, 1 ) )
End Function

Function KD_V ( )
Return ( GDI_GetAsyncKeyState ( VK_V, 1 ) )
End Function

Function KD_W ( )
Return ( GDI_GetAsyncKeyState ( VK_W, 1 ) )
End Function

Function KD_X ( )
Return ( GDI_GetAsyncKeyState ( VK_X, 1 ) )
End Function

Function KD_Y ( )
Return ( GDI_GetAsyncKeyState ( VK_Y, 1 ) )
End Function

Function KD_Z ( )
Return ( GDI_GetAsyncKeyState ( VK_Z, 1 ) )
End Function

Function KD_1 ( )
Return ( GDI_GetAsyncKeyState ( VK_1, 1 ) )
End Function

Function KD_2 ( )
Return ( GDI_GetAsyncKeyState ( VK_2, 1 ) )
End Function

Function KD_3 ( )
Return ( GDI_GetAsyncKeyState ( VK_3, 1 ) )
End Function

Function KD_4 ( )
Return ( GDI_GetAsyncKeyState ( VK_4, 1 ) )
End Function

Function KD_5 ( )
Return ( GDI_GetAsyncKeyState ( VK_5, 1 ) )
End Function

Function KD_6 ( )
Return ( GDI_GetAsyncKeyState ( VK_6, 1 ) )
End Function

Function KD_7 ( )
Return ( GDI_GetAsyncKeyState ( VK_7, 1 ) )
End Function

Function KD_8 ( )
Return ( GDI_GetAsyncKeyState ( VK_8, 1 ) )
End Function

Function KD_9 ( )
Return ( GDI_GetAsyncKeyState ( VK_9, 1 ) )
End Function

Function KD_0 ( )
Return ( GDI_GetAsyncKeyState ( VK_0, 1 ) )
End Function

Function W_UP ( )
Return ( KD_W ( )Or KD_UP ( ) ) 
End Function

Function S_DOWN ( )
Return ( KD_S ( )Or KD_DOWN ( ) ) 
End Function

Function A_LEFT ( )
Return ( KD_A ( )Or KD_LEFT ( ) ) 
End Function

Function D_RIGHT ( )
Return ( KD_D ( )Or KD_RIGHT ( ) ) 
End Function

Function KD_SPACE ( )
Return ( GDI_GetAsyncKeyState ( VK_SPACE, 1 ) )
End Function

Function KD_BACKSPACE ( )
Return ( GDI_GetAsyncKeyState ( VK_BACKSPACE, 1 ) )
End Function

Function CONTROL ( )
Return ( GDI_GetAsyncKeyState ( VK_LEFTCTRL, 1 ) Or GDI_GetAsyncKeyState ( VK_RIGHTCTRL, 1 ) )
End Function

Function SHIFT ( )
Return ( GDI_GetAsyncKeyState ( VK_LEFTSHIFT, 1 ) Or GDI_GetAsyncKeyState ( VK_RIGHTSHIFT, 1 ) )
End Function

Function SPACE ( )
Return ( GDI_GetAsyncKeyState ( VK_SPACE, 1 ) )
End Function

Function KD_UP ( )
Return ( GDI_GetAsyncKeyState ( VK_UP, 1 ) )
End Function

Function KD_DOWN ( )
Return ( GDI_GetAsyncKeyState ( VK_DOWN, 1 ) )
End Function

Function KD_LEFT ( )
Return ( GDI_GetAsyncKeyState ( VK_LEFT, 1 ) )
End Function

Function KD_RIGHT ( )
Return ( GDI_GetAsyncKeyState ( VK_RIGHT, 1 ) )
End Function

Function CONTROL_SHIFT ( )
Return ( CONTROL ( )And SHIFT ( ) ) 
End Function

Function CONTROL_SPACE ( )
Return ( CONTROL ( )And SPACE ( ) ) 
End Function

Function CONTROL_SHIFT_SPACE ( )
Return ( CONTROL_SHIFT ( )And SPACE ( ) ) 
End Function

Function CONTROL_SHIFT_SPACE_UP ( )
Return ( CONTROL ( )And SHIFT ( )And SPACE ( )And KD_UP ( ) ) 
End Function

Function CONTROL_SHIFT_SPACE_DOWN ( )
Return ( CONTROL ( )And SHIFT ( )And SPACE ( )And KD_DOWN ( ) ) 
End Function

Function CONTROL_SHIFT_SPACE_LEFT ( )
Return ( CONTROL ( )And SHIFT ( )And SPACE ( )And KD_LEFT ( ) ) 
End Function

Function CONTROL_SHIFT_SPACE_RIGHT ( )
Return ( CONTROL ( )And SHIFT ( )And SPACE ( )And KD_RIGHT ( ) ) 
End Function

Function CONTROL_SHIFT_SPACE_RETURN ( )
Return ( CONTROL ( )And SHIFT ( )And SPACE ( )And KD_RETURN ( ) ) 
End Function

Function CONTROL_SHIFT_UP ( )
Return ( CONTROL ( )And SHIFT ( )And KD_UP ( ) ) 
End Function

Function CONTROL_SHIFT_DOWN ( )
Return ( CONTROL ( )And SHIFT ( )And KD_DOWN ( ) ) 
End Function

Function CONTROL_SHIFT_LEFT ( )
Return ( CONTROL ( )And SHIFT ( )And KD_LEFT ( ) ) 
End Function

Function CONTROL_SHIFT_RIGHT ( )
Return ( CONTROL ( )And SHIFT ( )And KD_RIGHT ( ) ) 
End Function

Function CONTROL_SHIFT_RETURN ( )
Return ( CONTROL ( )And SHIFT ( )And KD_RETURN ( ) ) 
End Function

Function CONTROL_SPACE_UP ( )
Return ( CONTROL ( )And SPACE ( )And KD_UP ( ) ) 
End Function

Function CONTROL_SPACE_DOWN ( )
Return ( CONTROL ( )And SPACE ( )And KD_DOWN ( ) ) 
End Function

Function CONTROL_SPACE_LEFT ( )
Return ( CONTROL ( )And SPACE ( )And KD_LEFT ( ) ) 
End Function

Function CONTROL_SPACE_RIGHT ( )
Return ( CONTROL ( )And SPACE ( )And KD_RIGHT ( ) ) 
End Function

Function CONTROL_SPACE_RETURN ( )
Return ( CONTROL ( )And SPACE ( )And KD_RETURN ( ) ) 
End Function

Function CONTROL_UP ( )
Return ( CONTROL ( )And KD_UP ( ) ) 
End Function

Function CONTROL_DOWN ( )
Return ( CONTROL ( )And KD_DOWN ( ) ) 
End Function

Function CONTROL_LEFT ( )
Return ( CONTROL ( )And KD_LEFT ( ) ) 
End Function

Function CONTROL_RIGHT ( )
Return ( CONTROL ( )And KD_RIGHT ( ) ) 
End Function

Function CONTROL_RETURN ( )
Return ( CONTROL ( )And KD_RETURN ( ) ) 
End Function

Function KD_RETURN ( )
Return ( GDI_GetASyncKeyState ( VK_RETURN, 1 ) )
End Function