;******** DX7 Simple Planetary test *********


;init gfx mode 
Graphics3D 800,600,32,2


AppTitle "DirectX7 Planetary Test"


; Setup fonts to be used
; 2Dfonts
;font=dxLoadFont("arial",50,0,0,0)
;font2=dxLoadFont("times",18,True,True,0)
;dxSetFont font

SetBuffer BackBuffer() ; set the current drawing buffer
Global speed=10
Global mode$="Side"

; Setup Camera   
Global campivot= CreatePivot()


Global camera=CreateCamera(campivot) 	   ;create a standard camera

MoveEntity camera, 0, 0, -15	           ;Move cam away from sun(so we can see something)

;CameraZoom camera, 1.6 ; fixes the warped planets look(happens under certain conditions)

;Setup Light
light=CreateLight() 
AmbientLight 255,255,255; 0,0,0

;Setup Pivots.
pivot1  = CreatePivot()      ; for moving entire solarsystem or sun?

pivot4  = CreatePivot()      ; for Earth

;Setup Bodies.
;SUN
sun=CreateSphere(32)
ScaleEntity sun,2.5,2.5,2.5

suntexture=LoadTexture("..\images\suncyl1.jpg") ; use texture or just color entity.
EntityTexture sun,suntexture
EntityColor sun,255,255,0	 
EntityFX sun,1
EntityShininess sun,1
EntityAlpha sun,1

;EARTH
earth=CreateSphere(32,pivot4)
ScaleEntity earth,.35,.35,.35

earthtexture=LoadTexture("..\images\earth.jpg") ; use texture or just color entity.
EntityTexture earth,earthtexture
;EntityColor earth,0,0,200
EntityShininess earth,1
EntityFX earth,1
EntityAlpha earth,1

MoveEntity earth, 9, 0, 0




.Mainloop
While Not KeyHit(1) ;Esc =exit

	;move bodies
	TurnEntity sun,0,1,0       		    ; spin sun
	TurnEntity pivot4,0,0.15,0    		; speed  ; move earth trajectory
	TurnEntity earth,0,1,0       		; spin earth



	;control functions
	Control()

	UpdateWorld ; update coords
	RenderWorld ; display the scene into our double buffer
	Text 400,600,"DirectX7 Planetary Test"
	Text 440,620,"ViewMode: "+mode$
	
	Flip 1; flip buffer into sight 

Wend
EndGraphics
End

Function Control()
    ;-------- camcontrol -------
	If KeyDown(57)Then
		WaitKey()
	EndIf	

	If KeyDown(200) Then ;Up= Cam Closer
		MoveEntity camera,0,0,0.1
	EndIf

	If KeyDown(208) Then ; Down= Cam Further
		MoveEntity camera,0,0,-0.1	
	EndIf

	If KeyDown(205) Then ;  Left = move cam left
		MoveEntity camera,0.1,0,0
	EndIf

	If KeyDown(203) Then ;  Right = turn cam right
		MoveEntity camera,-0.1,0,0
	EndIf
    ;--------- View ---------
	If KeyDown(2) Then ; 1=SideView
		RotateEntity campivot, 0,0,0,0
		
		
		mode$="Side"
	EndIf
	If KeyDown(3) Then ; 2=TopView	
		RotateEntity campivot, 90,0,0,0
		
		
		mode$="Top"
	EndIf
End Function