;******** DX9 Simple Planetary test *********

;init gfx mode 
dxGraphics3D 800,600,32,2
dxApptitle "DirectX9 Planetary Test"
; Setup fonts to be used
; 2Dfonts
;font=dxLoadFont("courier new",16,0,0,0)
;font2=dxLoadFont("times",18,True,True,0)
;dxSetFont font

dxSetBuffer dxBackBuffer() ; set the current drawing buffer
Global speed=10
Global mode$="Side"

; Setup Camera   
Global campivot= dxCreatePivot(0)
Global camera=dxCreateCamera(campivot) 	   ;create a standard camera
dxMoveEntity camera, 0, 0, -15	           ;Move cam away from sun(so we can see something)
;dxCameraZoom camera, 1.6 ; fixes the warped planets look(happens under certain conditions)
;Setup Light
light=dxCreateLight(2,0) 
dxAmbientLight 255,255,255; 0,0,0
;Setup Pivots.
pivot1  = dxCreatePivot(0)      ; for moving entire solarsystem or sun?
pivot4  = dxCreatePivot(0)      ; for Earth
;Setup Bodies.
;SUN
sun=dxCreateSphere(32,0)
dxScaleEntity sun,2.5,2.5,2.5,True

suntexture=dxLoadTexture("..\images\suncyl1.jpg",9) ; use texture or just color entity.
dxEntityTexture sun,suntexture,0,0
dxEntityColor sun,255,255,0	 
dxEntityFX sun,1
;dxEntityShininess sun,1
dxEntityAlpha sun,1

;EARTH
earth=dxCreateSphere(32,pivot4)
dxScaleEntity earth,.35,.35,.35,True

earthtexture=dxLoadTexture("..\images\earth.jpg",9) ; use texture or just color entity.
dxEntityTexture earth,earthtexture,0,0
;EntityColor earth,0,0,200
;dxEntityShininess earth,1
dxEntityFX earth,1
dxEntityAlpha earth,1

dxMoveEntity earth, 9, 0, 0


.Mainloop
While Not dxKeyHit(1) ;Esc =exit

	;move bodies
	dxTurnEntity sun,0,1,0,True       		    ; spin sun
	dxTurnEntity pivot4,0,0.15,0,True   		; speed  ; move earth trajectory
	dxTurnEntity earth,0,1,0,True       		; spin earth

	;control functions
	Control()

	;UpdateWorld ; update coords
	dxRenderWorld 0 ; display the scene into our double buffer
	dxText 400,600,"DirectX9 Planetary Test",0,0
	dxText 440,620,"ViewMode: "+mode$,0,0
	
	dxFlip 1 ; flip buffer into sight 

Wend
dxEndGraphics
End

Function Control()
    ;-------- camcontrol -------
	If dxKeyDown(57)Then
		dxWaitKey()
	EndIf	

	If dxKeyDown(200) Then ;Up= Cam Closer
		dxMoveEntity camera,0,0,0.1
	EndIf

	If dxKeyDown(208) Then ; Down= Cam Further
		dxMoveEntity camera,0,0,-0.1
	EndIf

	If dxKeyDown(205) Then ;  Left = move cam left
		dxMoveEntity camera,0.1,0,0
	EndIf

	If dxKeyDown(203) Then ;  Right = turn cam right
		dxMoveEntity camera,-0.1,0,0
	EndIf
    ;--------- View ---------
	If dxKeyDown(2) Then ; 1=SideView
		dxRotateEntity campivot, 0,0,0,0
		
		
		mode$="Side"
	EndIf
	If dxKeyDown(3) Then ; 2=TopView	
		dxRotateEntity campivot, 90,0,0,0
		mode$="Top"
	EndIf
End Function